<?php
/**
 * Created by PhpStorm.
 * User: rafaelpickbrenne
 * Date: 03/09/14
 * Time: 13:14
 * Este é baseado no \v_220\products\sources\modules\Folha\Facade\Relatorios\relatoriosFolha.php
 */

namespace Folha\Facade\Relatorios;


class relatoriosVAB {
    //Constantes para os lits dos relatórios
    const rlTran = 'RELATORIO_VAL_TRANS';

    //Constantes para os nomes dos fields.
    const nrOrg_ = 'NRORG';             //Constantes com '_' representam fields que não serão afetados pela visibilidade...
    const compe_ = 'MESCOMPETENCIA';    //...e se é requerido ou não. São usados apenas para leitura neste facade.
    //const moCal_ = 'MODALIDCAL'; //Na tela é exibido o campo MODALIDCAL_NOME, mas usa-se este para os relatórios.
    //const moSal_ = 'MODALIDSAL'; //todo Modalidade de salário está exibindo o nome também (como o madalidade de cálculo). Se necessário fazer o mesmo que feito no Modalidade de Cálculo
    //const ocorr_ = 'OCORRECAL';  //Campos desativados: MODALIDCAL, MODALIDCAL_NOME, MODALIDSAL e OCORRECAL
    const cdOpe_ = 'CDOPERADOR';
    const nmOpe_ = 'NMOPERADOR';
    const confi_ = 'CONFIDENCIAL';
    const vincu = 'NRVINCULO';
    const tpVin = 'TIPOVINCULO';
    const esLeg = 'ESTRUTLEGAL';
    const esGer = 'ESTRUTGEREN';
    const forne = 'FORNECEDOR';
    const zebra = 'ZEBRADO';
    const dtIni = 'DATAINICIO'; //Desabilitado
    const dtFim = 'DATAFINAL';  //Desabilitado
    const movim = 'MOVIMENTO';  //Desabilitado
    //todo fazer os demais

    //Constantes para as mensagens
    //Mensagem que alerta a falta de seleção de um relatório
    const msgSelRel = 'hrm_relatorio_folha_selecao';
    //Mensagem que alerta da não necessidade de se eselecionar mais de um parâmetro entre vínculo e estruturas legal e gerencial
    const msgMulEst = 'hrm_relatorio_folha_multipla';
    //Mensagem nome do relatório inválido ou o mesmo não está integrado
    const msgNomInv = 'hrm_relatorio_folha_nome_relatorio';

    private $nomeRelatorio;     //Nome do relatório
    private $nrOrganizacao;     //Número da organização
    private $cdOperador;        //Código do Operador

    //Array com os relatórios e suas configurações
    //Baseado no C:\workfolder\v_220\products\sources\modules\Folha\Facade\Relatorios\relatoriosFolha.php
    private $relatorios = array(
        'vale_transporte_solicitacao'=>array(
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::vincu=>'P_VINCULO',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::tpVin=>'P_TIPOVINCULO',self::forne=>'P_FORNECEDOR')),
        'vale_transporte_romaneio'=>array(
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::vincu=>'P_VINCULO',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::tpVin=>'P_TIPOVINCULO',self::forne=>'P_FORNECEDOR')),
        /*'nome_do_relatório'=>array(
            'parame'=>array(null)),*/
    );

    public function __construct(){       //Construtor
        $this->nomeRelatorio = tk_get_field_value(self::rlTran);
        $this->nrOrganizacao = tk_get_field_value(self::nrOrg_);
        $this->cdOperador    = tk_get_field_value(self::cdOpe_);
    }

    public function verificaVincEstrut(){               //Verifica multipla seleção no vínculo e estruturas
        $cont  = tk_get_field_value(self::vincu) != null ? 1 : 0;
        $cont += tk_get_field_value(self::esLeg) != null ? 1 : 0;
        $cont += tk_get_field_value(self::esGer) != null ? 1 : 0;
        if($cont > 1)   //Verifica se há mais de um campo preenchido
            tk_message(tk_get_message_by_name(self::msgMulEst));
    }

    public function abrirRelatorio(){                   //Abre o relatório selecionado
        $nome = $this->nomeRelatorio;
        switch($nome){
            case 'inicio':  //Se não foi selecionado um nome de relatório este lança um aviso ao usuário para fazê-lo
            case '':
                tk_warning(tk_get_message_by_name(self::msgSelRel));
                break;
            default:        //Todos os relatórios, inclusive as opções inválidas
                if(isset($this->relatorios[$nome])){ //Verifica se o relatório existe
                        $param = array();   //Array de parâmetros para a função tk_open_report_from_array abrir o relatório
                        foreach($this->relatorios[$nome]['parame'] as $cam => $par)
                            $param[$par] = tk_get_field_value($cam);
                            tk_open_report_from_array($nome, $param, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
                } else {    //Relatório não existe no array de configuração
                    tk_warning(tk_get_message_by_name(self::msgNomInv, array($nome)));
                }
        }
    }
} 