<?php
namespace Indeterminado\Repositories;


/**
 *
 */
class Itemorcaop extends \Doctrine\ORM\EntityRepository
{

    /**
     * Retorna a soma dos valores do orcamento do mes, de acordo com o mes recebido via parametro.
     *
     * @param $cdfilial
     * @param \DateTime $dataEntradaNF
     * @param $cdversorcaop
     * @param $nrorg
     *
     * @throws \Exception
     * @return float
     */
    public function getOrcamentoDeConsumo($cdfilial, \DateTime $dataEntradaNF, $cdversorcaop, $nrorg)
    {
        $mes = $dataEntradaNF->format("m");
        $ano = $dataEntradaNF->format("Y");

        $idOrcamentoDeConsumo = \Indeterminado\Entities\Itemorcaop::TIPO_ORCAMENTO_CONSUMO;

        $sql = "SELECT SUM(NVL(DECODE(
                    '$mes',
                    '01', VRORCAMENTOJAN,
                    '02', VRORCAMENTOFEV,
                    '03', VRORCAMENTOMAR,
                    '04', VRORCAMENTOABR,
                    '05', VRORCAMENTOMAI,
                    '06', VRORCAMENTOJUN,
                    '07', VRORCAMENTOJUL,
                    '08', VRORCAMENTOAGO,
                    '09', VRORCAMENTOSET,
                    '10', VRORCAMENTOOUT,
                    '11', VRORCAMENTONOV,
                    '12', VRORCAMENTODEZ
                  ), 0)) VRORCAMENTOC
                  FROM ITEMORCAOP
                  WHERE CDFILIAL     = '$cdfilial'
                    AND CDVERSORCAOP = '$cdversorcaop'
                    AND IDTIPOORCAOP = '$idOrcamentoDeConsumo'
                    AND NRANOORCAOP  = $ano
                    AND NRORG        = $nrorg";

        try {
            return $this->getEntityManager()->getConnection()->fetchColumn($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    /**
     * Verificacao de orcamento conforme entrada.
     *
     * @param $cdfilial
     * @param \DateTime $dataEntradaNF
     * @param $cdversorcaop
     * @param $cdtipooper
     * @param $nrorg
     *
     * @return float
     *
     * @throws \Exception
     */
    public function getOrcamentoDespesasEntrada($cdfilial, \DateTime $dataEntradaNF, $cdversorcaop, $cdtipooper, $nrorg)
    {
        $mes = $dataEntradaNF->format("m");
        $ano = $dataEntradaNF->format("Y");

        $sql = "SELECT SUM(NVL(DECODE(
                            '$mes',
                            '01', VRORCAMENTOJAN,
                            '02', VRORCAMENTOFEV,
                            '03', VRORCAMENTOMAR,
                            '04', VRORCAMENTOABR,
                            '05', VRORCAMENTOMAI,
                            '06', VRORCAMENTOJUN,
                            '07', VRORCAMENTOJUL,
                            '08', VRORCAMENTOAGO,
                            '09', VRORCAMENTOSET,
                            '10', VRORCAMENTOOUT,
                            '11', VRORCAMENTONOV,
                            '12', VRORCAMENTODEZ
                        ), 0)) VRORCAMENTOE
                  FROM ITEMORCAOP
                  WHERE CDFILIAL     = '$cdfilial'
                    AND NRANOORCAOP  = '$ano'
                    AND CDVERSORCAOP = '$cdversorcaop'
                    AND IDTIPOORCAOP = '" . \Indeterminado\Entities\Itemorcaop::TIPO_ORCAMENTO_DESPESAS_ENTRADA . "'
                    AND CDTIPOOPER   = '$cdtipooper'
                    AND NRORG        = $nrorg";

        try {
            return (float)$this->getEntityManager()->getConnection()->fetchColumn($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }

}